class Labirinto { //<>//

  int w = 71, h = 71;
  int[][] maze = new int[w][h];
  
  Labirinto(int largura, int altura) {
    w = largura; h = altura;
    gerar();
  }
  
  void gerar() {
    zerar();
    maze[0][0] = 1;
    passo(0,0);
  }

  void zerar() {
    for (int i = 0; i < w; i++) {
      for (int j = 0; j < h; j++) { 
        maze[i][j] = 0;
      }
    }
  }

  void passo(int x, int y) {

    IntList ordem = new IntList();
    ordem.append(0); 
    ordem.append(1); 
    ordem.append(2); 
    ordem.append(3);
    ordem.shuffle();
    int indice = 0;

    for (indice = 0; indice < 4; indice++) {
      switch(ordem.get(indice)) {
      case 0: 
        {
          if (x+2 < w) {
            if (maze[x+2][y] != 1) {
              maze[x+1][y] = 1;
              maze[x+2][y] = 1;
              passo(x+2, y);
            }
          }
          break;
        }
      case 1: 
        {
          if (x-2 >= 0) {
            if (maze[x-2][y] != 1) {
              maze[x-1][y] = 1;
              maze[x-2][y] = 1;
              passo(x-2, y);
            }
          }
          break;
        }
      case 2: 
        {
          if (y+2 < h) {
            if (maze[x][y+2] != 1) {
              maze[x][y+1] = 1;
              maze[x][y+2] = 1;
              passo(x, y+2);
            }
          }
          break;
        }
      case 3: 
        {
          if (y-2 >= 0) {
            if (maze[x][y-2] != 1) {
              maze[x][y-1] = 1;
              maze[x][y-2] = 1;
              passo(x, y-2);
            }
          }
          break;
        }
      }
    }
  }

  void desenhar() {
    clear();
    background(200);
    float modulo = (width/(w+2));
    float subModulo = (width-(modulo*2))/w;
    fill(0); 
    rect(modulo, modulo, width-(modulo*2), width-(modulo*2));
    noStroke();
    fill(255);
    // 0 - Parede Branco... 1 - Caminho Preto
    for (int i = 0; i < w; i++) {
      for (int j = 0; j < h; j++) {
        if (maze[i][j] == 0) { 
          rect(modulo+(i*subModulo), modulo+(j*subModulo), subModulo, subModulo);
        }
      }
    }
  }
}